'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.viewCSS = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
// @jsx glam


var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _glam = require('glam');

var _glam2 = _interopRequireDefault(_glam);

var _primitives = require('../primitives');

require('../types');

var _utils = require('../utils');

var _componentHelpers = require('./component-helpers');

var _componentBaseClassNames = require('./componentBaseClassNames');

var _componentBaseClassNames2 = _interopRequireDefault(_componentBaseClassNames);

var _useNativeLazyLoading = require('@charlietango/use-native-lazy-loading');

var _useNativeLazyLoading2 = _interopRequireDefault(_useNativeLazyLoading);

var _reactIntersectionObserver = require('react-intersection-observer');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var viewCSS = exports.viewCSS = function viewCSS() {
  return {
    lineHeight: 0,
    position: 'relative',
    textAlign: 'center'
  };
};

var viewBaseClassName = _componentBaseClassNames2.default.View;

var View = function View(props) {
  var data = props.data,
      formatters = props.formatters,
      getStyles = props.getStyles,
      index = props.index,
      isFullscreen = props.isFullscreen,
      isModal = props.isModal;

  var innerProps = {
    alt: formatters.getAltText({ data: data, index: index }),
    src: (0, _componentHelpers.getSource)({ data: data, isFullscreen: isFullscreen })
  };

  var supportsLazyLoading = (0, _useNativeLazyLoading2.default)();

  var _useInView = (0, _reactIntersectionObserver.useInView)({
    triggerOnce: true,
    skip: supportsLazyLoading !== false
  }),
      _useInView2 = _slicedToArray(_useInView, 2),
      ref = _useInView2[0],
      inView = _useInView2[1];

  return (0, _glam2.default)(
    _primitives.Div,
    {
      ref: ref,
      css: getStyles(viewBaseClassName, props),
      className: (0, _utils.className)(viewBaseClassName, { isFullscreen: isFullscreen, isModal: isModal })
    },
    inView || supportsLazyLoading ? (0, _glam2.default)(_primitives.Img, _extends({}, innerProps, {
      className: (0, _utils.className)('view-image', { isFullscreen: isFullscreen, isModal: isModal }),
      loading: 'lazy',
      css: {
        height: 'auto',
        maxHeight: '100%',
        maxWidth: '100%',
        userSelect: 'none'
      }
    })) : null
  );
};

exports.default = View;